data class Comment(
    //Old format
    val text :String?,
    /**Localized relative time to the time of when comments were downloaded - worst accuracy is probably ~6 months
     * if we know date of download - this will get converted to UNIX time when converting if selected (if implemented)*/
    val time :String?,
    /**Non-Unique name of channel/user*/
    val author :String?,
    /**Comment id OR the ID of comment this comment is replying to separated by "."*/
    val cid :String?,
    //new format ONLY
    val heart :Boolean?,
    val votes :String?,
    /**Direct URL to .jpeg of users avatar*/
    val photo :String?,
    /**ID appendable to https://www.youtube.com/channel/[channel] for direct link*/
    val channel :String?,
) {
    /**Checks for missing fields to determine if this is newer version of comment JSON
     * @return true if this was newer version JSON*/
    fun isNewFormat() :Boolean {
        //For simplicity we check only for photo field as I don't know if there are other comment json variations floating around
        photo?.let { return true }
        return false
    }

    fun isCommentReply() :Boolean {
        cid?.let { return it.contains(".") }
        return false
    }

    fun getCommentID() :String {
         cid?.let {
             return if (it.contains(".")) { it.split(".")[1] } else { it }
        }
        return "Comment has no ID"
    }
}
