/**Parses arguments from command line*/
object Config {
    /**Input file for what ever we are currently doing, but it's probably some JSON*/
    var inputFile :String = "./comments.json"
    /**Currently this is output for whatever we are doing right now*/
    var outputFile :String = "./out.html"
    /**Video that we will be linked to the html*/
    var videoToLink :String = "./video.webm"

    var fixing :Boolean = false
    var avatars :Boolean = false

    fun parseConfig(args :Array<String>) {
        var i = 0 //just for end user info in case of errors
        try {
            //not using for each because we need to access current index
            for (j in args.indices) {
                i = j
                when (args[j].toLowerCase()) {
                    "convert" -> { fixing = false; avatars = false} //this will get ugly if more will be added
                    "fixjson" -> { fixing = true; avatars = false }
                    "avatars" -> { avatars = true; fixing = false}
                    "-i" -> inputFile = args[j+1]
                    "-o" -> outputFile = args[j+1]
                    "-v" -> videoToLink = args[j+1]
                }
            }
        } catch (iobe :ArrayIndexOutOfBoundsException) {
            System.err.println("Error: option \"" + args[i] + "\" has no valid argument")
        }
    }

    fun printHelp() {
        println("Help - Usage:")
        println("videoarchiver [command] [-arguments]\n")
        println("Commands:\nfixJson - takes input json (-i) and writes fixed json to (-o)")
        println("convert - takes input json (-i) (optional) -v for video and -o for output\n")
        println("avatars - more incomplete than others, takes -i for file and dumps all avatars to current dir")
        println("Examples:\nvideoarchiver convert -i FiWcomments.json -v FiW1.webm -o Fiw1.html")
        println("videoarchiver fixJson -i downloaded.json -o Fiw1.json ")
        println("videoarchiver avatars -i comments.json - This dumps avatars to the current dir")
    }
}