import com.google.gson.Gson
import com.google.gson.JsonSyntaxException
import java.io.BufferedReader
import java.io.FileInputStream
import java.io.FileNotFoundException
import java.io.InputStreamReader
import kotlin.system.exitProcess

fun main(args: Array<String>) {

    if (args.isEmpty()) {
        Config.printHelp()
        exitProcess(0)
    }

    Config.parseConfig(args)

    if (Config.fixing) {
        println("Fixing (${Config.inputFile} -> ${Config.outputFile})...")
        Utils.fixJson(Config.inputFile, Config.outputFile)
        println("Done!")
        exitProcess(0)
    }
    val gson = Gson()
    val comments :Array<Comment>
    try {
        comments = gson.fromJson(BufferedReader(InputStreamReader(FileInputStream(Config.inputFile))),Array<Comment>::class.java)
    } catch (e :Exception) {
        when(e) {
            is JsonSyntaxException -> {
                println("Broken json - it may be fixable with \"fixJson\" command"); exitProcess(1)
            }
            is FileNotFoundException -> {
                println("Given file not found: $e"); exitProcess(1)
            }
        }
        println("Unknown error: $e")
        exitProcess(0)
    }

    if (Config.avatars) {
        println("Downloading avatars for given JSON (${Config.inputFile})...")
        Utils.downloadAllAvatars(comments)
        println("Done!")
        exitProcess(0)
    }

    if (!Config.fixing) { //it can't even be anything else
        println("Generating HTML for (${Config.inputFile} -> ${Config.outputFile}) video: ${Config.videoToLink}...")
        HtmlWriter.basicLinkedComments(comments)
        println("Done!")
        exitProcess(0)
    }
    println("Whoa if this happened there is seroius error somewhere...")
}
